/* --- The following code comes from c:\lcc\lib\wizard\textmode.tpl. */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
void Usage(char *programName)
{
	fprintf(stderr,"%s N <infilename> usage:\n",programName);
	fprintf(stderr,"Strips N columns (tabs=8) from left of input file.\n");
	fprintf(stderr,"outfilename is infilename+.asm.\n");
	fprintf(stderr,"asks before overwriting output file\n");
	fprintf(stderr,"Used to turn source listing to .ASM listing.\n");
	fprintf(stderr,"%s -h prints this message.\n", programName);
	return;
}

/* returns the number of arguments up to two */
int HandleOptions(int argc,char *argv[])
{
	int i,options=0;

	for (i=1; i< argc;i++) {
		if (argv[i][0] == '/' || argv[i][0] == '-') {
			switch (argv[i][1]) {
				/* An argument -? means help is requested */
				case '?':
					Usage(argv[0]);
					return -1;
					break;
				case 'h':
				case 'H':
					if (!stricmp(argv[i]+1,"help")) {
						Usage(argv[0]);
						return -1;
						break;
					}

				default:
					fprintf(stderr,"unknown option %s\n",argv[i]);
					Usage(argv[0]);
					return -1;
					break;
			}
		}
		else { /* string is filename or number want exactly two */
			if (options==0 || options==1) options++;
			else {
				fprintf(stderr, "too many arguments\n");
				return -1;
			}
		}
	}
	if (options != 2) {
		fprintf(stderr, "too few arguments\n");
		return -1;
	}
	return options; /* only returns 2 if successful */
}

int printbuf(char buffer[], int cols, FILE *outfile) {
	/* print buffer to outfile "after" column cols */
		int buflen;
		int goodcols, j;
		char thechar;
		int outerr;

		buflen = strlen(buffer);
		/* printf("strlen is %i, first chars are: ->%c%c%c<-\n", buflen, buffer[0], buffer[1], buffer[2]); */
		if (buflen <= cols) { /* string shorter than desired columns to remove */
			goodcols = 0;
			for (j=0;j<buflen;j++) {
				thechar = buffer[j];
				if (thechar=='\t') goodcols = (8+((goodcols+1)/8)*8);
				else if (thechar > 0x1F) goodcols++; /* not tab but some control chars */
				if (goodcols >= cols) break;
			}
			/*printf("%i,%i|",j,goodcols); */
			if (goodcols < cols) outerr = fputs("\n", outfile); /* short string */
			else outerr = fprintf(outfile, buffer+j+1, "%s");
			if (outerr == EOF) {
				printf ("write error or EOF on output file\n");	return -1;
			}
			return 0;
		}

		/* string longer than desired columns to remove */
		goodcols = 0;
		for (j=0;j<cols;j++) {
			if (buffer[j]!= '\t') goodcols++; else 	goodcols = (8+((goodcols+1)/8)*8);
			/*printf("%i,%i|",j,goodcols); */
			if (goodcols >= cols) break;
		}

		/* printf("%s",buffer+j+1); print to screen */
		if (fprintf(outfile, buffer+j+1, "%s")== EOF) {
			printf("write error or EOF on output file\n");
			return -1;
		}
		return 0;
}

int main(int argc,char *argv[])
{
	int option; /* index of options in command line */
	FILE *infile;
	FILE *outfile;
	char filename[80]; /* look for this file */
	char outname[85];
	int fnamelen; /* length of filename */
	char buffer[512+80];
	int bufind, buflen; /*index into buffer and length of string */
	int i, j, founddot;
	int namepos=0; /*location of filename in imagefile*/
	int cols, goodcols; /* number of left columns to delete, correct cols with tabs=8 */
	int overwrite; /* true 1 or false 0 to overwrite output file*/


	if (argc == 1) {
		/* If no arguments we call the Usage routine and exit */
		Usage(argv[0]);
		return 1;
	}
	/* handle the program options */

	option = HandleOptions(argc,argv);
	/* returns -1 on error, 0 if help request or index to first filename*/
	if (option < 2) return -1; /* error */
	/*otherwise see HandleOption for syntax */
	printf("option 1 is count %s\n", argv[1]);
	printf("option 2 is filename %s\n", argv[2]);

	/* process count of colums */

	cols = atoi(argv[1]);
	if (cols == 0) {
		printf("zero columns to delete for %i?\n",cols);
		return -1;
	}
	if (cols > 80) {
		printf("too many columns to delete for %i?\n",cols);
		return -1;
	}
	printf("%i columns to delete\n",cols);

	/* process filename to find */
	fnamelen = strlen(argv[2]);
	if (fnamelen < 80) strcpy(filename, argv[2]); else {
		fprintf(stderr,"filename too long  %s\n", argv[2]);
		return -1;
	} /* else filetofindname is filename to look for AND output file */
	printf("input filename is *%s*\n", filename);

	/* create filename.asm for output, remove any other extension */
	founddot = 0;
	for (i=0;i<fnamelen;i++) {
		outname[i]=filename[i];
		if (outname[i]=='.') {
			founddot = 1;
			strcpy(outname+i+1, "asm\0");
			break;
		}
	}
	if (founddot==0) strcpy(outname+fnamelen, ".asm\n");
	printf("Output filename is *%s*\n",outname);


	/* open input  file for read */
	infile = fopen(filename,"r");
	if (infile == 0) {
		fprintf(stderr,"input file %s not found\n", filename);
		return -1;
	}

	printf("main: past openfile input file\n");


	/* open output file for read to see if exists */
	overwrite = 1;
	outfile = fopen(outname,"r");
	if (outfile != 0) { /* it exists */
		fprintf(stderr,"output file %s exists, overwrite?\n", outname);
		/* get yes or no input, set overwrite 1 for yes 0 for no */
		/* close output file either way */
		if (fclose (outfile)!= 0) {
			fprintf(stderr,"output file opened for read %s not closed\n", outname);
			return -1;
		}
	} /* else output file does not exist, we will open it below */

	/* if no overwrite close files and exit*/
	if (overwrite == 0) {
		fprintf(stderr,"no overwrite, close and exit\n");
		fclose (infile);
		return -1;
	}

	/* if yes to overwrite, or new file, open for write and go on*/
	outfile = fopen(outname,"w");
	if (outfile == 0) {
		fprintf(stderr,"output file %s not found\n", outname);
		return -1;
		}

	printf("main: past openfile output file\n");

	/* read line by line, search for nth column in line, print line out */

	namepos = 0; buffer[0]=0;
	while (1) {
		fgets(buffer, 512, infile);
		if (buffer == NULL) {
			fprintf(stderr,"input file read error\n");
			namepos = -1;
			break;
		}
		if (feof(infile)) {
			printf("\nEOF after %i lines\n",namepos);
			break;
		}
		if (printbuf(buffer,cols,outfile) != 0) break;
		namepos = namepos + 1;
		/* printf("."); /*show a trail*/
	}

	/* close files */
	if (fclose (infile)!=0) {
		fprintf(stderr,"input file %s not closed\n", argv[option]);
		return -1;
	}

	if (fclose (outfile)!=0) {
		fprintf(stderr,"output file %s not closed\n", outname);
		return -1;
	}
	printf("main: past closefile input & output file\n");
	return 0;
}
